## This program is free software: you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation, either version 3 of the License, or (at
## your option) any later version.

## This program is distributed in the hope that it will be useful, but
## WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
## General Public License for more details.

## You should have received a copy of the GNU General Public License
## along with this program (in the file LICENCE-GPLv3.txt).  If not, see
## <http://www.gnu.org/licenses/>.


from Path import *

import os, csv

class NameFactory:
	def __init__(self, csv_files_dirs, latitude_column_index, longitude_column_index):
		# get the list of all files passed directly or contained in passed directories
		self.csv_files = []
		
		self.latitude_column_index = latitude_column_index
		self.longitude_column_index = longitude_column_index
		
		for file_or_dir_name in csv_files_dirs:
                    if (not os.path.isfile(file_or_dir_name)):
                        raise NameError, "file or directory %s doesn't exist" % file_or_dir_name
		    if (os.path.isdir(file_or_dir_name)):
		        dir_files = os.listdir(file_or_dir_name)
		        for filename_in_dir in dir_files:
        			self.csv_files.append(os.path.realpath(file_or_dir_name + os.sep + filename_in_dir))
		    elif (os.path.isfile(file_or_dir_name)):
		        self.csv_files.append(os.path.realpath(file_or_dir_name))
		     
	def extractRawPaths(self):
		paths = []
	   	for filename in self.csv_files:
                        # deduce csv format
                        csvfile = open(filename, 'rb')
                        dialect = csv.Sniffer().sniff(csvfile.read(4096))
                        csvfile.seek(0)               
                        # create a csv file reader
	    		reader = csv.reader(csvfile, dialect)
                                       
			# create and fill a list of longiture and latitude pairs
	    		list = []
	    		reader.next()

                        for row in reader:
	    			lat, lng = float(row[self.latitude_column_index ][:-1]), float(row[self.longitude_column_index][:-1])
				pair = -lng, lat
	       			list.append(pair)
	       		p = Path(filename, list)
	       		paths.append(p)
	       	return paths
        

        def extractPathsWithFixedDiscontinuities(self):
		paths = []
                # time csv index
                time_index = 3
	   	## for filename in self.csv_files:
                ##         # deduce csv format
                ##         csvfile = open(filename, 'rb')
                ##         dialect = csv.Sniffer().sniff(csvfile.read(4096))
                ##         csvfile.seek(0)               
                ##         # create a csv file reader
	    	## 	reader = csv.reader(csvfile, dialect)
                                       
		## 	# create and fill a list of longiture and latitude pairs
	    	## 	list = []
	    	## 	reader.next()

                ##         for row in reader:
	    	## 		lat, lng = float(row[self.latitude_column_index ][:-1]), float(row[self.longitude_column_index][:-1])
		## 		pair = -lng, lat
	       	## 		list.append(pair)

	       	## 	p = Path(filename, list)
	       	## 	paths.append(p)
	       	## return paths
	       	
       	
